/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.62 by edhill, Thu Jan 15 19:19:59 2004 UTC revision 1.96 by edhill, Mon Aug 9 02:28:51 2004 UTC
# Line 37  test_for_string_in_file() { Line 37  test_for_string_in_file() {
37      grep -i "$strng" $file > /dev/null 2>&1      grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo -n "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
41          grep -i "$strng" $file          grep -i "$strng" $file
42          return 1          return 1
43      fi      fi
# Line 67  expand_pkg_groups() { Line 67  expand_pkg_groups() {
67          done          done
68          PACKAGES=$new_packages          PACKAGES=$new_packages
69          rm -f ./p[1,2].tmp          rm -f ./p[1,2].tmp
70            return $matched
71      else      else
72          echo "Warning: can't read package groups definition file: $PKG_GROUPS"          echo "Warning: can't read package groups definition file: $PKG_GROUPS"
73      fi      fi
74  }  }
75    
76    #  Check for broken environments (eg. cygwin, MacOSX w/HFS+) that
77    #  cannot distinguish [*.F/*.F90] from [*.f/*.f90] files.
78    check_for_broken_Ff()  {
79        #  Do we have defaults for $FS and/or $FS90 ?
80        tfs=f
81        tfs9=f90
82        if test "x$FS" != x ; then
83            tfs="$FS"
84        fi
85        if test "x$FS90" != x ; then
86            tfs9="$FS90"
87        fi
88    
89        #  First check the ability to create a *.F/.f pair.
90        cat <<EOF >> genmake_hello.F
91          program hello
92          write(*,*) 'hi'
93          stop
94          end
95    EOF
96        cp genmake_hello.F "genmake_hello."$tfs > /dev/null 2>&1
97        RETVAL=$?
98        if test "x$RETVAL" != x0 ; then
99            if test "x$FS" = x ; then
100                FS='for'
101                FS90='fr9'
102                check_for_broken_Ff
103            else
104                cat <<EOF 2>&1
105    ERROR: Your file system cannot distinguish between *.F and *.f files
106      (fails the "cp" test) and this program cannot find a suitable
107      replacement extension.  Please try a different build environment or
108      contact the <MITgcm-support@mitgcm.org> list for help.
109    
110    EOF
111                exit -1
112            fi
113            return
114        fi
115        rm -f genmake_hello.*
116    
117        #  Check the ability of ${MAKE} and ${LN} to use the current set
118        #  of extensions.
119        cat <<EOF >> genmake_hello.F
120          program hello
121          write(*,*) 'hi'
122          stop
123          end
124    EOF
125        test -f Makefile  &&  mv -f Makefile Makefile.bak
126        cat <<EOF >> Makefile
127    %.$tfs : %.F
128    .SUFFIXES:
129    genmake_hello.$tfs: genmake_hello.F
130            $LN genmake_hello.F genmake_hello.$tfs
131    EOF
132        $MAKE "genmake_hello."$tfs > /dev/null 2>&1
133        RETVAL=$?
134        if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
135            if test "x$FS" = x ; then
136                FS='for'
137                FS90='fr9'
138                check_for_broken_Ff
139            else
140                cat <<EOF 2>&1
141    ERROR: Your file system cannot distinguish between *.F and *.f files
142      (fails the "make/ln" test) and this program cannot find a suitable
143      replacement extension.  Please try a different build environment or
144      contact the <MITgcm-support@mitgcm.org> list for help.
145    
146    EOF
147                exit -1
148                return
149            fi
150        fi
151        rm -f genmake_hello.* Makefile
152        test -f Makefile  &&  mv -f Makefile.bak Makefile
153    
154        #  If we make it here, use the extensions
155        FS=$tfs
156        FS90=$tfs9
157        return
158    }
159    
160    
161    look_for_makedepend()  {
162    
163        #  The "original" makedepend is part of the Imake system that is
164        #  most often distributed with XFree86 or with an XFree86 source
165        #  package.  As a result, many machines (eg. generic Linux) do not
166        #  have a system-default "makedepend" available.  For those
167        #  systems, we have two fall-back options:
168        #
169        #    1) a makedepend implementation shipped with the cyrus-imapd
170        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
171        #
172        #    2) a known-buggy xmakedpend shell script
173        #
174        #  So the choices are, in order:
175        #
176        #    1) use the user-specified program
177        #    2) use a system-wide default
178        #    3) locally build and use the cyrus implementation
179        #    4) fall back to the buggy local xmakedpend script
180        #
181        if test "x${MAKEDEPEND}" = x ; then
182            which makedepend > /dev/null 2>&1
183            RV0=$?
184            cat <<EOF >> genmake_tc.f
185          program test
186          write(*,*) 'test'
187          stop
188          end
189    EOF
190            makedepend genmake_tc.f > /dev/null 2>&1
191            RV1=$?
192            if test "x${RV0}${RV1}" = x00 ; then
193                MAKEDEPEND=makedepend
194            else
195                echo "    a system-default makedepend was not found."
196                
197                #  Try to build the cyrus implementation
198                build_cyrus_makedepend
199                RETVAL=$?
200                if test "x$RETVAL" != x0 ; then
201                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
202                fi
203                rm -f ./genmake_cy_md
204            fi
205        else
206            #  echo "MAKEDEPEND=${MAKEDEPEND}"
207            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
208            RETVAL=$?
209            if test x"$RETVAL" = x0 ; then
210                build_cyrus_makedepend
211            fi
212        fi
213    }
214    
215    
216    build_cyrus_makedepend()  {
217        rm -f ./genmake_cy_md
218        (
219            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
220                &&  ./configure > /dev/null 2>&1  \
221                &&  make > /dev/null 2>&1
222            if test -x ./makedepend.exe ; then
223                $LN ./makedepend.exe ./makedepend
224            fi
225            ./makedepend ifparser.c > /dev/null 2>&1  \
226                &&  echo "true"
227        ) > ./genmake_cy_md
228        grep true ./genmake_cy_md > /dev/null 2>&1
229        RETVAL=$?
230        rm -f ./genmake_cy_md
231        if test "x$RETVAL" = x0 ; then
232            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
233            return 0
234        else
235            echo "WARNING: unable to build cyrus-imapd-makedepend"
236            return 1
237        fi
238    }
239    
240  # Guess possible config options for this host  # Guess possible config options for this host
241  find_possible_configs()  {  find_possible_configs()  {
242    
# Line 80  find_possible_configs()  { Line 245  find_possible_configs()  {
245      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
246      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
247      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
248      PLATFORM=$tmp2      tmp3=`echo $tmp2 | sed -e 's/cray sv1/craysv1/'`
249        PLATFORM=$tmp3
250        echo $PLATFORM | grep cygwin > /dev/null 2>&1  &&  PLATFORM=cygwin_ia32
251      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
252      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
253            
# Line 100  find_possible_configs()  { Line 267  find_possible_configs()  {
267          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
268      fi      fi
269    
270      # makedepend is not always available      look_for_makedepend
271      if test "x${MAKEDEPEND}" = x ; then  
272        which makedepend >& /dev/null      #================================================================
273        RETVAL=$?      #  look for possible C compilers
274        if test "x${RETVAL}" = x1 ; then      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc"
275           echo "    makedepend was not found. Using xmakedpend instead."      p_CC=
276           MAKEDEPEND='$(TOOLSDIR)/xmakedepend'      for c in $tmp ; do
277        fi          rm -f ./genmake_hello.c  ./genmake_hello
278            cat >> genmake_hello.c << EOF
279    #include <stdio.h>
280    int main(int argc, char **argv) {
281      printf("Hello!\n");
282      return 0;
283    }
284    EOF
285            $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
286            RETVAL=$?
287            if test "x${RETVAL}" = x0 ; then
288                p_CC="$p_CC $c"
289            fi
290        done
291        rm -f ./genmake_hello.c ./genmake_hello
292        if test "x${p_CC}" = x ; then
293            cat 1>&2 <<EOF
294    
295    Error: No C compilers were found in your path.  Please specify one using:
296    
297        1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
298        2) the CC or MITGCM_CC environment variables.
299    
300    EOF
301            exit 1
302        else
303            echo "  The possible C compilers found in your path are:"
304            echo "   "$p_CC
305            if test "x$CC" = x ; then
306                CC=`echo $p_CC | $AWK '{print $1}'`
307                echo "  Setting C compiler to: "$CC
308            fi
309      fi      fi
310    
311      # look for possible fortran compilers      #================================================================
312        #  look for possible FORTRAN compilers
313      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"
314      p_FC=      p_FC=
315      for c in $tmp ; do      for c in $tmp ; do
# Line 136  Error: No Fortran compilers were found i Line 335  Error: No Fortran compilers were found i
335    
336      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
337      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
338      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
339    
340  EOF  EOF
341          exit 1          exit 1
# Line 145  EOF Line 344  EOF
344          echo "   "$p_FC          echo "   "$p_FC
345          if test "x$FC" = x ; then          if test "x$FC" = x ; then
346              FC=`echo $p_FC | $AWK '{print $1}'`              FC=`echo $p_FC | $AWK '{print $1}'`
347                echo "  Setting FORTRAN compiler to: "$FC
348          fi          fi
349      fi      fi
350    
351      for i in $p_FC ; do      if test "x$OPTFILE" = x ; then
352          p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i          OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$FC
353          if test -r $p_OF ; then          if test ! -r $OPTFILE ; then
354              OPTFILE=$p_OF               echo "  I looked for the file "$OPTFILE" but did not find it"
355              echo "  The options file:  $p_OF"          fi
356              echo "    appears to match so we'll use it."      fi
357              break  #    echo "  The options file:  $p_OF"
358          fi  #    echo "    appears to match so we'll use it."
359      done  #   for i in $p_FC ; do
360    #p_OF=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
361    #if test -r $p_OF ; then
362    #    OPTFILE=$p_OF
363    #    echo "  The options file:  $p_OF"
364    #    echo "    appears to match so we'll use it."
365    #    break
366    #fi
367    #   done
368      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
369          cat 1>&2 <<EOF          cat 1>&2 <<EOF
370    
# Line 215  get_pdepend_list()  { Line 423  get_pdepend_list()  {
423      . ./.pd_tmp      . ./.pd_tmp
424      rm -f ./.pd_tmp      rm -f ./.pd_tmp
425    
426      echo -n "PNAME = "${}      printf "PNAME = "${}
427  }  }
428    
429    
# Line 229  Usage: "$0" [OPTIONS] Line 437  Usage: "$0" [OPTIONS]
437      -help | --help | -h | --h      -help | --help | -h | --h
438            Print this help message and exit.            Print this help message and exit.
439    
440        -adoptfile NAME | --adoptfile NAME | -adof NAME | --adof NAME
441          -adoptfile=NAME | --adoptfile=NAME | -adof=NAME | --adof=NAME
442              Use "NAME" as the adoptfile.  By default, the file at
443              "tools/adjoint_options/adjoint_default" will be used.
444    
445      -nooptfile | --nooptfile      -nooptfile | --nooptfile
446        -optfile NAME | --optfile NAME | -of NAME | --of NAME        -optfile NAME | --optfile NAME | -of NAME | --of NAME
447        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
# Line 253  Usage: "$0" [OPTIONS] Line 466  Usage: "$0" [OPTIONS]
466        --makefile=NAME | -mf=NAME        --makefile=NAME | -mf=NAME
467            Call the makefile "NAME".  The default is "Makefile".            Call the makefile "NAME".  The default is "Makefile".
468    
469        -makedepend NAME | -md NAME
470          --makedepend=NAME | -md=NAME
471              Use "NAME" for the MAKEDEPEND program.
472    
473      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
474        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
475            Specify the location of the MITgcm ROOTDIR as "NAME".            Specify the location of the MITgcm ROOTDIR as "NAME".
# Line 289  Usage: "$0" [OPTIONS] Line 506  Usage: "$0" [OPTIONS]
506            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
507            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
508    
509        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
510              Use "NAME" as the C compiler.  By default, genmake
511              will search for a working compiler by trying a list of
512              "usual suspects" such as gcc, c89, cc, etc.
513    
514      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
515            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
516            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
517            is being used.            is being used.
518    
519        -mpi | --mpi
520              Include MPI header files and link to MPI libraries
521        -mpi=PATH | --mpi=PATH
522              Include MPI header files and link to MPI libraries using MPI_ROOT
523              set to PATH. i.e. Include files from \$PATH/include, link to libraries
524              from \$PATH/lib and use binaries from \$PATH/bin.
525    
526        -bash NAME
527              Explicitly specify the Bourne or BASH shell to use
528    
529    While it is most often a single word, the "NAME" variables specified    While it is most often a single word, the "NAME" variables specified
530    above can in many cases be a space-delimited string such as:    above can in many cases be a space-delimited string such as:
531    
# Line 314  EOF Line 546  EOF
546    
547  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
548  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
549    
550        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
551        if test ! "x$FC_NAMEMANGLE" = x ; then
552            return 0
553        fi
554    
555      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
556            
557      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 331  WARNING: Please contact <MITgcm-support@ Line 569  WARNING: Please contact <MITgcm-support@
569  EOF  EOF
570          return 1          return 1
571      fi      fi
572      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
573      RETVAL=$?      RETVAL=$?
574      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
575          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 361  WARNING: Please contact <MITgcm-support@ Line 599  WARNING: Please contact <MITgcm-support@
599  EOF  EOF
600          return 1          return 1
601      fi      fi
602      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
603      RETVAL=$?      RETVAL=$?
604      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
605          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 438  EOF Line 676  EOF
676    
677    
678  check_netcdf_libs()  {  check_netcdf_libs()  {
679      cat <<EOF > genmake_tnc.F      echo "" > genmake_tnc.log
680        cat <<EOF > genmake_tnc.for
681        program fgennc        program fgennc
682  #include "netcdf.inc"  #include "netcdf.inc"
683        integer iret, ncid, xid        integer iret, ncid, xid
# Line 450  check_netcdf_libs()  { Line 689  check_netcdf_libs()  {
689        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
690        end        end
691  EOF  EOF
692      $CPP genmake_tnc.F > genmake_tnc.f  \      #echo "$CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f"
693          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1      #echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.f"
694        #echo "$LINK -o genmake_tnc.o $LIBS"
695        $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
696            &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.f  \
697            &&  $LINK -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
698      RET_COMPILE=$?      RET_COMPILE=$?
699      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
700      RETVAL=$?      RETVAL=$?
701      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
702          HAVE_NETCDF=t          HAVE_NETCDF=t
703      else      else
704          cat genmake_tnc.log >> genmake_warnings          # try again with "-lnetcdf" added to the libs
705            $CPP $DEFINES $INCLUDES genmake_tnc.for > genmake_tnc.f 2>/dev/null  \
706                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
707                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
708            RET_COMPILE=$?
709            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
710            RETVAL=$?
711            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
712                LIBS="$LIBS -lnetcdf"
713                HAVE_NETCDF=t
714            else
715                cat genmake_tnc.log >> genmake_warnings
716            fi
717      fi      fi
718      rm -f genmake_tnc*      rm -f genmake_tnc*
719  }  }
720    
721    
722    
723    ###############################################################################
724    #   Sequential part of script starts here
725    ###############################################################################
726    
727  #  Set defaults here  #  Set defaults here
728  COMMANDL="$0 $@"  COMMANDL="$0 $@"
729    
# Line 472  LN= Line 732  LN=
732  S64=  S64=
733  KPP=  KPP=
734  FC=  FC=
735    #CC=gcc
736  CPP=  CPP=
737  LINK=  LINK=
 # DEFINES="-DWORDLENGTH=4"  
738  DEFINES=  DEFINES=
739  PACKAGES=  PACKAGES=
740  ENABLE=  ENABLE=
741  DISABLE=  DISABLE=
742  MAKEFILE=  MAKEFILE=
743  MAKEDEPEND=  #MAKEDEPEND=
744  PDEPEND=  PDEPEND=
745  DUMPSTATE=t  DUMPSTATE=t
746  PDEFAULT=  PDEFAULT=
# Line 491  FOPTIM= Line 751  FOPTIM=
751  CFLAGS=  CFLAGS=
752  KFLAGS1=  KFLAGS1=
753  KFLAGS2=  KFLAGS2=
754    #LDADD=
755  LIBS=  LIBS=
756  KPPFILES=  KPPFILES=
757  NOOPTFILES=  NOOPTFILES=
758  NOOPTFLAGS=  NOOPTFLAGS=
759    MPI=
760    MPIPATH=
761    
762  # DEFINES checked by test compilation  # DEFINES checked by test compilation
763  HAVE_SYSTEM=  HAVE_SYSTEM=
# Line 502  HAVE_FDATE= Line 765  HAVE_FDATE=
765  FC_NAMEMANGLE=  FC_NAMEMANGLE=
766  HAVE_CLOC=  HAVE_CLOC=
767  HAVE_NETCDF=  HAVE_NETCDF=
768    HAVE_ETIME=
769    
770  MODS=  MODS=
771  TOOLSDIR=  TOOLSDIR=
# Line 509  SOURCEDIRS= Line 773  SOURCEDIRS=
773  INCLUDEDIRS=  INCLUDEDIRS=
774  STANDARDDIRS="USE_THE_DEFAULT"  STANDARDDIRS="USE_THE_DEFAULT"
775    
776    G2ARGS=
777    BASH=
778  PWD=`pwd`  PWD=`pwd`
779  MAKE=make  MAKE=make
780  AWK=awk  AWK=awk
# Line 524  IEEE= Line 790  IEEE=
790  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
791      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
792  fi  fi
793    FS=
794    FS90=
795    
796  AUTODIFF_PKG_USED=f  AUTODIFF_PKG_USED=f
797  AD_OPTFILE=  AD_OPTFILE=
# Line 548  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE Line 816  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPE
816  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
817  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"
818  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
819  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
820    
821  #  The following are all related to adjoint/tangent-linear stuff  #  The following are all related to adjoint/tangent-linear stuff
822  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"  gm_s10="AUTODIFF_PKG_USED AD_OPTFILE TAMC TAF AD_TAMC_FLAGS AD_TAF_FLAGS"
# Line 577  for i in . $MODS ; do Line 845  for i in . $MODS ; do
845          break          break
846      fi      fi
847  done  done
848  echo -n "  getting local config information:  "  printf "  getting local config information:  "
849  if test -e $gm_local ; then  if test -f $gm_local ; then
850      echo "using $gm_local"      echo "using $gm_local"
851      . $gm_local      . $gm_local
852      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 599  fi Line 867  fi
867  #done  #done
868  #parse_options  #parse_options
869  ac_prev=  ac_prev=
870  for ac_option ; do  for ac_option in $@ ; do
871    
872        G2ARGS="$G2ARGS \"$ac_option\""
873    
874      # If the previous option needs an argument, assign it.      # If the previous option needs an argument, assign it.
875      if test -n "$ac_prev"; then      if test -n "$ac_prev"; then
# Line 642  for ac_option ; do Line 912  for ac_option ; do
912          -make=* | --make=* | -m=* | --m=*)          -make=* | --make=* | -m=* | --m=*)
913              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
914                    
915            -bash | --bash)
916                ac_prev=BASH ;;
917            -bash=* | --bash=*)
918                BASH=$ac_optarg ;;
919            
920            -makedepend | --makedepend | -md | --md)
921                ac_prev=MAKEDEPEND ;;
922            -makedepend=* | --makedepend=* | -md=* | --md=*)
923                MAKEDEPEND=$ac_optarg ;;
924            
925          -makefile | --makefile | -ma | --ma)          -makefile | --makefile | -ma | --ma)
926              ac_prev=MAKEFILE ;;              ac_prev=MAKEFILE ;;
927          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
# Line 683  for ac_option ; do Line 963  for ac_option ; do
963  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
964  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
965  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
966                        
967            -cc | --cc)
968                ac_prev=CC ;;
969            -cc=* | --cc=*)
970                CC=$ac_optarg ;;
971            
972          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
973              ac_prev=FC ;;              ac_prev=FC ;;
974          -fc=* | --fc=*)          -fc=* | --fc=*)
975              FC=$ac_optarg ;;              FC=$ac_optarg ;;
976                    
977            -fs | --fs)
978                ac_prev=FS ;;
979            -fs=* | --fs=*)
980                FS=$ac_optarg ;;
981            
982            -fs90 | --fs90)
983                ac_prev=FS90 ;;
984            -fs90=* | --fs90=*)
985                FS90=$ac_optarg ;;
986            
987          -ieee | --ieee)          -ieee | --ieee)
988              IEEE=true ;;              IEEE=true ;;
989          -noieee | --noieee)          -noieee | --noieee)
990              IEEE= ;;              IEEE= ;;
991    
992            -mpi | --mpi)
993                MPI=true ;;
994            -mpi=* | --mpi=*)
995                MPIPATH=$ac_optarg
996                MPI=true ;;
997                    
998  #       -jam | --jam)  #       -jam | --jam)
999  #           JAM=1 ;;  #           JAM=1 ;;
# Line 739  if test -f ./.genmakerc ; then Line 1040  if test -f ./.genmakerc ; then
1040  fi  fi
1041    
1042  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1043      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1044        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then
1045          ROOTDIR=".."          ROOTDIR=".."
1046      else      else
1047          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
1048              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then              if [ -d "$d/model" -a -d "$d/eesupp" -a -d "$d/pkg" ]; then
1049                  ROOTDIR=$d                  ROOTDIR=$d
1050                  echo -n "Warning:  ROOTDIR was not specified but there appears to be"                  printf "Warning:  ROOTDIR was not specified but there appears to be"
1051                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."                  echo " a copy of MITgcm at \"$ROOTDIR\" so we'll try it."
1052                  break                  break
1053              fi              fi
# Line 779  if test "x$OPTFILE" != xNONE ; then Line 1081  if test "x$OPTFILE" != xNONE ; then
1081          . "$OPTFILE"          . "$OPTFILE"
1082          RETVAL=$?          RETVAL=$?
1083          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1084              echo -n "Error: failed to source OPTFILE \"$OPTFILE\""              printf "Error: failed to source OPTFILE \"$OPTFILE\""
1085              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1086              exit 1              exit 1
1087          fi          fi
# Line 792  if test "x$OPTFILE" != xNONE ; then Line 1094  if test "x$OPTFILE" != xNONE ; then
1094      fi      fi
1095  fi  fi
1096    
1097    #  Check for broken systems that cannot correctly distinguish *.F and *.f files
1098    # check_for_broken_Ff
1099    
1100  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1101  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1102      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 806  if test "x${AD_OPTFILE}" != xNONE ; then Line 1111  if test "x${AD_OPTFILE}" != xNONE ; then
1111          . "$AD_OPTFILE"          . "$AD_OPTFILE"
1112          RETVAL=$?          RETVAL=$?
1113          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1114              echo -n "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""              printf "Error: failed to source AD_OPTFILE \"$AD_OPTFILE\""
1115              echo "--please check that variable syntax is bash-compatible"              echo "--please check that variable syntax is bash-compatible"
1116              exit 1              exit 1
1117          fi          fi
# Line 819  if test "x${AD_OPTFILE}" != xNONE ; then Line 1124  if test "x${AD_OPTFILE}" != xNONE ; then
1124      fi      fi
1125  fi  fi
1126    
1127  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1128  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1129    if test ! "x$BASH" = x ; then
1130        # add a trailing space so that it works within the Makefile syntax (see below)
1131        BASH="$BASH "
1132    fi
1133  if test "x$FC" = x ; then  if test "x$FC" = x ; then
1134      cat <<EOF 1>&2      cat <<EOF 1>&2
1135    
# Line 831  Error: no Fortran compiler: please speci Line 1140  Error: no Fortran compiler: please speci
1140  EOF  EOF
1141      exit 1      exit 1
1142  fi  fi
1143    if test "x$CC" = x ; then
1144        CC=cc
1145    #     cat <<EOF 1>&2
1146    # Error: no C compiler: please specify using one of the following:
1147    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1148    #   2) the "-cc=XXX" command-line option
1149    #   3) the "./genmake_local" file
1150    # EOF
1151    #     exit 1
1152    fi
1153  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1154      LINK=$FC      LINK=$FC
1155  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
1156  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1157      MAKE="make"      MAKE="make"
1158  fi  fi
1159    if test "x$CPP" = x ; then
1160        CPP=cpp
1161    fi
1162    #EH3 === UGLY ===
1163    #  The following is an ugly little hack to check for $CPP in /lib/ and
1164    #  it should eventually be replaced with a more general function that
1165    #  searches a combo of the user's path and a list of "usual suspects"
1166    #  to find the correct location for binaries such as $CPP.
1167    for i in " " "/lib/" ; do
1168        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
1169    done
1170    #EH3 === UGLY ===
1171  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
1172  RETVAL=$?  RETVAL=$?
1173  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 856  EOF Line 1184  EOF
1184  else  else
1185      rm -f test_cpp      rm -f test_cpp
1186  fi  fi
1187  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1188  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1189      LN="ln -s"      LN="ln -s"
1190  fi  fi
# Line 876  EOF Line 1202  EOF
1202  fi  fi
1203  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1204    
1205    #  Check for broken *.F/*.f handling and fix if possible
1206    check_for_broken_Ff
1207    
1208    if test ! "x$MPI" = x ; then
1209          echo "  Turning on MPI cpp macros"
1210          DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1211    fi
1212    
1213  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1214  echo -n "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1215  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1216        program hello        program hello
1217        call system('echo hi')        call system('echo hi')
# Line 896  else Line 1229  else
1229  fi  fi
1230  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1231    
1232  echo -n "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1233  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.f <<EOF
1234        program hello        program hello
1235        CHARACTER(128) string        CHARACTER(128) string
# Line 917  else Line 1250  else
1250  fi  fi
1251  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1252    
1253  echo -n "  Can we call simple C routines (here, \"cloc()\") using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1254    cat > genmake_tcomp.f <<EOF
1255          program hello
1256          REAL*4 ACTUAL, TARRAY(2)
1257          EXTERNAL ETIME
1258          REAL*4 ETIME
1259          actual = etime( tarray )
1260          print *, tarray
1261          end
1262    EOF
1263    $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1
1264    RETVAL=$?
1265    if test "x$RETVAL" = x0 ; then
1266        HAVE_ETIME=t
1267        DEFINES="$DEFINES -DHAVE_ETIME"
1268        echo "yes"
1269    else
1270        HAVE_ETIME=
1271        echo "no"
1272    fi
1273    rm -f genmake_tcomp*
1274    
1275    printf "  Can we call simple C routines (here, \"cloc()\") using $FC...  "
1276  check_HAVE_CLOC  check_HAVE_CLOC
1277  if test "x$HAVE_CLOC" != x ; then  if test "x$HAVE_CLOC" != x ; then
1278      echo "yes"      echo "yes"
# Line 926  else Line 1281  else
1281  fi  fi
1282  rm -f genmake_t*  rm -f genmake_t*
1283    
1284  echo -n "  Can we create NetCDF-enabled binaries...  "  printf "  Can we create NetCDF-enabled binaries...  "
1285  check_netcdf_libs  check_netcdf_libs
1286  if test "x$HAVE_NETCDF" != x ; then  if test "x$HAVE_NETCDF" != x ; then
1287      echo "yes"      echo "yes"
# Line 936  fi Line 1291  fi
1291    
1292    
1293  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1294  echo -n "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1295  for d in $MODS ; do  for d in $MODS ; do
1296      if test ! -d $d ; then      if test ! -d $d ; then
1297          echo          echo
1298          echo "Error: MODS directory \"$d\" not found!"          echo "Error: MODS directory \"$d\" not found!"
1299          exit 1          exit 1
1300      else      else
1301          echo -n " $d"          printf " $d"
1302          SOURCEDIRS="$SOURCEDIRS $d"          SOURCEDIRS="$SOURCEDIRS $d"
1303          INCLUDEDIRS="$INCLUDEDIRS $d"          INCLUDEDIRS="$INCLUDEDIRS $d"
1304      fi      fi
# Line 958  if test "x${PLATFORM}" = x ; then Line 1313  if test "x${PLATFORM}" = x ; then
1313  fi  fi
1314    
1315  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1316      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | awk '{print $NR}'`
1317        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1318          EXEDIR=../exe          EXEDIR=../exe
1319      else      else
1320          EXEDIR=.          EXEDIR=.
# Line 973  if test "x${TOOLSDIR}" = x ; then Line 1329  if test "x${TOOLSDIR}" = x ; then
1329      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
1330  fi  fi
1331  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
1332      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
1333      exit 1      exit 1
1334  fi  fi
1335  if test "x$S64" = x ; then  if test "x$S64" = x ; then
# Line 1068  else Line 1424  else
1424          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1425          RETVAL=$?          RETVAL=$?
1426          if test "x${RETVAL}" != x0 ; then          if test "x${RETVAL}" != x0 ; then
1427              echo -n "Error: can't parse default package list "              printf "Error: can't parse default package list "
1428              echo "-- please check PDEFAULT=\"$PDEFAULT\""              echo "-- please check PDEFAULT=\"$PDEFAULT\""
1429              exit 1              exit 1
1430          fi          fi
# Line 1076  else Line 1432  else
1432              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1433          done          done
1434          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1435          expand_pkg_groups          RET=1
1436            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1437          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1438      fi      fi
1439  fi  fi
1440    
1441  echo "  applying DISABLE settings"  echo "  applying DISABLE settings"
1442    for i in $PACKAGES ; do
1443        echo $i >> ./.tmp_pack
1444    done
1445    for i in `grep  "-" ./.tmp_pack` ; do
1446        j=`echo $i | sed 's/[-]//'`
1447        DISABLE="$DISABLE $j"
1448    done
1449  pack=  pack=
1450  for p in $PACKAGES ; do  for p in $PACKAGES ; do
1451      addit="t"      addit="t"
# Line 1098  PACKAGES="$pack" Line 1462  PACKAGES="$pack"
1462  echo "  applying ENABLE settings"  echo "  applying ENABLE settings"
1463  echo "" > ./.tmp_pack  echo "" > ./.tmp_pack
1464  PACKAGES="$PACKAGES $ENABLE"  PACKAGES="$PACKAGES $ENABLE"
1465    # Test if each explicitly referenced package exists
1466  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1467      if test ! -d "$ROOTDIR/pkg/$i" ; then      j=`echo $i | sed 's/[-+]//'`
1468        if test ! -d "$ROOTDIR/pkg/$j" ; then
1469          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""          echo "Error: can't find package $i at \"$ROOTDIR/pkg/$i\""
1470          exit 1          exit 1
1471      fi      fi
1472      echo $i >> ./.tmp_pack      echo $i >> ./.tmp_pack
1473  done  done
 pack=`cat ./.tmp_pack | sort | uniq`  
 rm -f ./.tmp_pack  
1474  PACKAGES=  PACKAGES=
1475  for i in $pack ; do  for i in `grep -v "-" ./.tmp_pack | sort | uniq` ; do
1476      PACKAGES="$PACKAGES $i"      PACKAGES="$PACKAGES $i"
1477  done  done
1478    rm -f ./.tmp_pack
1479  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1480    
1481  echo "  applying package dependency rules"  echo "  applying package dependency rules"
# Line 1177  while test "x$ck" != xtt ; do Line 1542  while test "x$ck" != xtt ; do
1542              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
1543              exit 1              exit 1
1544          fi          fi
1545          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
1546            #i=$(( $i + 1 ))
1547      done      done
1548      ck=$ck"t"      ck=$ck"t"
1549  done  done
# Line 1209  if test "x$RETVAL" = x0 ; then Line 1575  if test "x$RETVAL" = x0 ; then
1575          cat make_mnc.errors 1>&2          cat make_mnc.errors 1>&2
1576          exit 1          exit 1
1577      fi      fi
1578      if test -a "x$HAVE_NETCDF" != xt ; then      if test "x$HAVE_NETCDF" != xt ; then
1579          cat <<EOF          cat <<EOF
1580    
1581  WARNING: the "mnc" package has been enabled but tests failed to  WARNING: the "mnc" package has been enabled but tests failed to
# Line 1339  echo Line 1705  echo
1705  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
1706  echo "  setting INCLUDES"  echo "  setting INCLUDES"
1707  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
1708      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
1709          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
1710      fi      fi
1711  done  done
# Line 1351  rm -rf .links.tmp Line 1715  rm -rf .links.tmp
1715  mkdir .links.tmp  mkdir .links.tmp
1716  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
1717  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
1718  echo -n 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
1719  echo -n 'CSRCFILES = '   > csrclist.inc  printf 'CSRCFILES = '   > csrclist.inc
1720  echo -n 'F90SRCFILES = ' > f90srclist.inc  printf 'F90SRCFILES = ' > f90srclist.inc
1721  echo -n 'HEADERFILES = ' > hlist.inc  printf 'HEADERFILES = ' > hlist.inc
1722  echo -n 'AD_FLOW_FILES = ' > ad_flow_files.inc  printf 'AD_FLOW_FILES = ' > ad_flow_files.inc
1723  alldirs="$SOURCEDIRS $INCLUDEDIRS ."  alldirs="$SOURCEDIRS $INCLUDEDIRS ."
1724  for d in $alldirs ; do  for d in $alldirs ; do
1725      deplist=      deplist=
# Line 1380  for d in $alldirs ; do Line 1744  for d in $alldirs ; do
1744                  case $extn in                  case $extn in
1745                      F)                      F)
1746                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
1747                          echo -n " $sf" >> srclist.inc                          printf " $sf" >> srclist.inc
1748                          ;;                          ;;
1749                      F90)                      F90)
1750                          echo    " \\"  >> f90srclist.inc                          echo    " \\"  >> f90srclist.inc
1751                          echo -n " $sf" >> f90srclist.inc                          printf " $sf" >> f90srclist.inc
1752                          ;;                          ;;
1753                      c)                      c)
1754                          echo    " \\"  >> csrclist.inc                          echo    " \\"  >> csrclist.inc
1755                          echo -n " $sf" >> csrclist.inc                          printf " $sf" >> csrclist.inc
1756                          ;;                          ;;
1757                      h)                      h)
1758                          echo    " \\"  >> hlist.inc                          echo    " \\"  >> hlist.inc
1759                          echo -n " $sf" >> hlist.inc                          printf " $sf" >> hlist.inc
1760                          ;;                          ;;
1761                      flow)                      flow)
1762                          echo    " \\"  >> ad_flow_files.inc                          echo    " \\"  >> ad_flow_files.inc
1763                          echo -n " $sf" >> ad_flow_files.inc                          printf " $sf" >> ad_flow_files.inc
1764                          ;;                          ;;
1765                  esac                  esac
1766              fi              fi
# Line 1416  echo "" >> f90srclist.inc Line 1780  echo "" >> f90srclist.inc
1780  echo "" >> hlist.inc  echo "" >> hlist.inc
1781  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
1782    
1783  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
1784      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
1785  fi  fi
1786  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1425  echo "#    $MACHINE" >> $MAKEFILE Line 1789  echo "#    $MACHINE" >> $MAKEFILE
1789  echo "# This makefile was generated automatically on" >> $MAKEFILE  echo "# This makefile was generated automatically on" >> $MAKEFILE
1790  echo "#    $THISDATE" >> $MAKEFILE  echo "#    $THISDATE" >> $MAKEFILE
1791  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
1792  echo "#    $0 $@" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
1793  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
1794  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE
1795    
# Line 1492  KPP = ${KPP} Line 1856  KPP = ${KPP}
1856  FC = ${FC}  FC = ${FC}
1857  # Fortran compiler  # Fortran compiler
1858  F90C = ${F90C}  F90C = ${F90C}
1859    # C compiler
1860    CC = ${CC}
1861  # Link editor  # Link editor
1862  LINK = ${LINK}  LINK = ${LINK} ${LDADD}
1863    
1864  # Defines for CPP  # Defines for CPP
1865  DEFINES = ${DEFINES}  DEFINES = ${DEFINES}
# Line 1525  cat csrclist.inc      >> $MAKEFILE Line 1891  cat csrclist.inc      >> $MAKEFILE
1891  cat f90srclist.inc    >> $MAKEFILE  cat f90srclist.inc    >> $MAKEFILE
1892  cat hlist.inc         >> $MAKEFILE  cat hlist.inc         >> $MAKEFILE
1893  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
1894  echo               >> $MAKEFILE  echo >> $MAKEFILE
1895  echo 'F77FILES =  $(SRCFILES:.F=.f)'                                           >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
1896  echo 'F90FILES =  $(F90SRCFILES:.F90=.f90)'                                    >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE
1897  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
1898    echo >> $MAKEFILE
1899    echo '.SUFFIXES:' >> $MAKEFILE
1900    echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
1901  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
1902  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
1903    
1904  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1905    
 .SUFFIXES:  
 .SUFFIXES: .o .f .p .F .c .F90 .f90  
   
1906  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1907  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1908          @echo Creating \$@ ...          @echo Creating \$@ ...
1909          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1910  depend:  depend:
1911          @make links          @make links
1912          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .$FS \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1913          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1914            -rm -f makedepend.out
1915    
1916  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1917    
# Line 1556  output.txt: \$(EXECUTABLE) Line 1922  output.txt: \$(EXECUTABLE)
1922          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1923    
1924  clean:  clean:
1925          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
1926  Clean:  Clean:
1927          @make clean          @make clean
1928          @make cleanlinks          @make cleanlinks
# Line 1567  CLEAN: Line 1933  CLEAN:
1933          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
1934          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
1935          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
1936          -rm -f \$(EXECUTABLE) output.txt          -rm -f \$(EXECUTABLE) output.txt STD*
1937    
1938  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1939  makefile:  makefile:
1940          $THIS_SCRIPT $@          $THIS_SCRIPT $G2ARGS
1941  cleanlinks:  cleanlinks:
1942          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1943    
1944  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets ($SPECIAL_FILES) which are create by make
1945  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1946          @echo Creating \$@ ...          @echo Creating \$@ ...
1947          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1948  AD_CONFIG.h:  AD_CONFIG.h:
1949          @echo Creating \$@ ...          @echo Creating \$@ ...
1950          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1951  FC_NAMEMANGLE.h:  FC_NAMEMANGLE.h:
1952          @echo Creating \$@ ...          @echo Creating \$@ ...
1953          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
1954    
1955  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
1956  .F.f:  
1957    %.o : %.F
1958    
1959    .F.$FS:
1960          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1961  .f.o:  .$FS.o:
1962          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
1963  .F90.f90:  .F90.$FS90:
1964          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1965  .f90.o:  .$FS90.o:
1966          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
1967  .c.o:  .c.o:
1968          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) -c \$<
1969    
1970  # Special exceptions that use the ( .F - .p - .f - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
1971  .F.p:  .F.p:
1972          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
1973  .p.f:  .p.$FS:
1974          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<          \$(KPP) \$(KFLAGS1)\$@ \$(KFLAGS2) \$<
1975    
1976  #=========================================  #=========================================
# Line 1628  done Line 1997  done
1997    
1998  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
1999  echo >> $MAKEFILE  echo >> $MAKEFILE
2000  echo -n "AD_FILES = " >> $MAKEFILE  printf "AD_FILES = " >> $MAKEFILE
2001  AD_FILES=`cat ad_files`  AD_FILES=`cat ad_files`
2002  for i in $AD_FILES ; do  for i in $AD_FILES ; do
2003      echo    " \\" >> $MAKEFILE      echo    " \\" >> $MAKEFILE
2004      echo -n " $i" >> $MAKEFILE      printf " $i" >> $MAKEFILE
2005  done  done
2006  echo >> $MAKEFILE  echo >> $MAKEFILE
2007  rm -f ad_files  rm -f ad_files
# Line 1645  adtaf: ad_taf_output.f Line 2014  adtaf: ad_taf_output.f
2014  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
2015    
2016  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2017          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2018          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2019          -rm -f ad_config.template          -rm -f ad_config.template
2020          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1677  ftltaf: ftl_taf_output.f Line 2046  ftltaf: ftl_taf_output.f
2046  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
2047    
2048  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
2049          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2050          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2051          -rm -f ftl_config.template          -rm -f ftl_config.template
2052          @make \$(F77FILES)          @make \$(F77FILES)
# Line 1726  for i in $KPPFILES ; do Line 2095  for i in $KPPFILES ; do
2095      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2096          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2097      fi      fi
2098      echo "$base.f: $base.p" >> $MAKEFILE      echo "$base.$FS: $base.p" >> $MAKEFILE
2099  done  done
2100    
2101  echo "  Making list of NOOPTFILES"  echo "  Making list of NOOPTFILES"
# Line 1736  for i in $NOOPTFILES ; do Line 2105  for i in $NOOPTFILES ; do
2105      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
2106          echo "Error: unable to add file \"$i\" to the exceptions list"          echo "Error: unable to add file \"$i\" to the exceptions list"
2107      fi      fi
2108      echo "$base.o: $base.f" >> $MAKEFILE      echo "$base.o: $base.$FS" >> $MAKEFILE
2109      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE      printf "\t\$(FC) \$(FFLAGS) \$(NOOPTFLAGS) -c \$<\n" >> $MAKEFILE
2110  done  done
2111    
# Line 1750  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 2119  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
2119  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
2120    
2121  # Create special header files  # Create special header files
2122  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"  $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
2123  if test ! -f $PACKAGES_DOT_H ; then  if test ! -f $PACKAGES_DOT_H ; then
2124      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
2125  else  else
# Line 1764  else Line 2133  else
2133      fi      fi
2134  fi  fi
2135  if test ! -f AD_CONFIG.h ; then  if test ! -f AD_CONFIG.h ; then
2136      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h      $BASH $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
2137  fi  fi
2138    
2139    
2140  #  Write the "state" for future records  #  Write the "state" for future records
2141  if test "x$DUMPSTATE" != xf ; then  if test "x$DUMPSTATE" != xf ; then
2142      echo -n "" > genmake_state      printf "" > genmake_state
2143      for i in $gm_state ; do      for i in $gm_state ; do
2144          t1="t2=\$$i"          t1="t2=\$$i"
2145          eval $t1          eval $t1

Legend:
Removed from v.1.62  
changed lines
  Added in v.1.96

  ViewVC Help
Powered by ViewVC 1.1.22